// Code generated by "enumer -type=Type -transform=snake -output=type_string.go -linecomment=true"; DO NOT EDIT.

package channel

import (
	"fmt"
)

const _TypeName = "no_typeinstagramtwitteryoutubefacebook"

var _TypeIndex = [...]uint8{0, 7, 16, 23, 30, 38}

const _TypeLowerName = "no_typeinstagramtwitteryoutubefacebook"

func (i Type) String() string {
	if i < 0 || i >= Type(len(_TypeIndex)-1) {
		return fmt.Sprintf("Type(%d)", i)
	}
	return _TypeName[_TypeIndex[i]:_TypeIndex[i+1]]
}

var _TypeValues = []Type{0, 1, 2, 3, 4}

var _TypeNameToValueMap = map[string]Type{
	_TypeName[0:7]:        0,
	_TypeLowerName[0:7]:   0,
	_TypeName[7:16]:       1,
	_TypeLowerName[7:16]:  1,
	_TypeName[16:23]:      2,
	_TypeLowerName[16:23]: 2,
	_TypeName[23:30]:      3,
	_TypeLowerName[23:30]: 3,
	_TypeName[30:38]:      4,
	_TypeLowerName[30:38]: 4,
}

var _TypeNames = []string{
	_TypeName[0:7],
	_TypeName[7:16],
	_TypeName[16:23],
	_TypeName[23:30],
	_TypeName[30:38],
}

// TypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func TypeString(s string) (Type, error) {
	if val, ok := _TypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to Type values", s)
}

// TypeValues returns all values of the enum
func TypeValues() []Type {
	return _TypeValues
}

// TypeStrings returns a slice of all String values of the enum
func TypeStrings() []string {
	strs := make([]string, len(_TypeNames))
	copy(strs, _TypeNames)
	return strs
}

// IsAType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i Type) IsAType() bool {
	for _, v := range _TypeValues {
		if i == v {
			return true
		}
	}
	return false
}
